---
title: Building up a basic demo with Three.js
slug: Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_Three.js
tags:
  - 3D
  - Animation
  - Beginner
  - Canvas
  - Games
  - Tutorial
  - WebGL
  - camera
  - lighting
  - rendering
  - three.js
---
<div>{{GamesSidebar}}</div>

<p class="summary">A typical 3D scene in a game — even the simplest one — contains standard items like shapes located in a coordinate system, a camera to actually see them, lights and materials to make it look better, animations to make it look alive, etc.<strong> Three.js</strong>, as with any other 3D library, provides built-in helper functions to help you implement common 3D functionality more quickly. <span class="seoSummary">In this article we'll take you through the real basics of using Three, including setting up a development environment, structuring the necessary HTML, the fundamental objects of Three, and how to build up a basic demo.</span></p>

<div class="note">
<p><strong>Note</strong>: We chose Three because it is one of the most popular <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> libraries, and it is easy to get started with. We are not trying to say it is better than any other WebGL library available, and you should feel free to try another library, such as <a href="http://www.ambiera.com/copperlicht/index.html">CopperLicht</a>, <a href="http://www.glge.org/">GLGE</a>, or <a href="https://playcanvas.com/">PlayCanvas</a>.</p>
</div>

<h2 id="Environment_setup">Environment setup</h2>

<p>To start developing with Three.js, you don't need much. You should:</p>

<ul>
 <li>Make sure you are using a modern browser with good <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> support, such as the latest Firefox or Chrome.</li>
 <li>Create a directory to store your experiments in.</li>
 <li>Save a copy of the <a href="http://threejs.org/build/three.min.js">latest minimized Three.js library</a> inside your directory.</li>
 <li>Open the <a href="http://threejs.org/docs/">Three.js documentation</a> in a separate tab — it is useful to refer to.</li>
</ul>

<h2 id="HTML_structure">HTML structure</h2>

<p>Here's the HTML structure we will use:</p>

<pre class="brush: html">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
	&lt;meta charset="utf-8"&gt;
	&lt;title&gt;MDN Games: Three.js demo&lt;/title&gt;
	&lt;style&gt;
		body { margin: 0; padding: 0; }
		canvas { width: 100%; height: 100%; }
	&lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;script src="three.min.js"&gt;&lt;/script&gt;
&lt;script&gt;
	var WIDTH = window.innerWidth;
	var HEIGHT = window.innerHeight;
	/* all our JavaScript code goes here */
&lt;/script&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<p>It contains some basic information like the document {{htmlelement("title")}}, and some CSS to set the <code>width</code> and <code>height</code> of the {{htmlelement("canvas")}} element, that Three.js will insert on the page to 100% to fill the entire available viewport space. The first {{htmlelement("script")}} element includes the Three.js library in the page, and we will write our example code inside the second. There are two helper variables already included, which store the window's <code>width</code> and <code>height</code>.</p>

<p>Before reading further, copy this code to a new text file, and save it in your working directory as <code>index.html</code>.</p>

<h2 id="Renderer">Renderer</h2>

<p>A renderer is a tool which displays scenes right in your browser. There are a few different renderers: WebGL is the default, and others you can use are Canvas, SVG, CSS, and DOM. They differ in how everything is rendered, so the WebGL implementation will implement differently than the CSS one. Despite the variety of ways they achieve the goal, the experience will look the same for the user. Thanks to this approach, a fallback can be used, if a desired technology is not supported by the browser.</p>

<pre class="brush: js">var renderer = new THREE.WebGLRenderer({antialias:true});
renderer.setSize(WIDTH, HEIGHT);
renderer.setClearColor(0xDDDDDD, 1);
document.body.appendChild(renderer.domElement);
</pre>

<p>We are creating a new WebGL renderer, setting its size to fit the whole available space on the screen, and appending the DOM structure to the page. You might have noticed the <code>antialias</code> parameter in the first line — this renders the edges of shapes more smoothly. The <code>setClearColor()</code> method sets our background to a light gray colour, instead of the default black one.</p>

<p>Add this code into our second {{htmlelement("script")}} element, just below the JavaScript comment.</p>

<h2 id="Scene">Scene</h2>

<p>A scene is the place where everything happens. When creating new objects in the demo, we add them all inside the scene to become visible on the screen. In three.js, the scene is represented by a <code>Scene</code> object. Let's create it, by adding the following line below our previous lines:</p>

<pre class="brush: js">var scene = new THREE.Scene();
</pre>

<p>Later, we will be using the <code>.add()</code> method, to add objects to this scene.</p>

<h2 id="Camera">Camera</h2>

<p>We have the rendered scene, but we still need to add a camera to view our handiwork — imagine a movie set without any cameras. The following lines put the camera in place in the 3D coordinate system, and point it in the direction of our scene, so we can finally see something:</p>

<pre class="brush: js">var camera = new THREE.PerspectiveCamera(70, WIDTH/HEIGHT);
camera.position.z = 50;
scene.add(camera);
</pre>

<p>Add the above lines to your code, below those previously added.</p>

<p>There are other types of camera available (Cube, Orthographic), but the simplest is Perspective. To initialize it, we have to set its field of view and aspect ratio: the former is used to set how much is seen, and the latter is important for the objects on the screen to have the right proportions when rendered, and not look stretched. Let's explain values we are setting for the code above:</p>

<ul>
 <li>The value we set for the field of view, 70, is something we can experiment with: the higher the value, the greater the amount of scene the camera will show. Imagine a normal camera view, versus a fish eye effect, which allows a lot more to be seen. The default value is 50.</li>
 <li>The aspect ratio is set to the current width and height of the window so it will be dynamically adjusted. We could set a fixed ratio — for example 16 ⁄ 9, which is the aspect ratio of a widescreen TV. The default value is 1.</li>
 <li>The <code>z</code> position, with the value of 50 units, is the distance between the camera and the center of the scene on the <code>z</code> axis. Here we're moving the camera back, so the objects in the scene can be viewed. 50 feels about right. It's not too near, or too far, and the sizes of the objects allow them to stay on the scene, within the given field of view. The <code>x</code> and <code>y</code> values, if not specified, will default to 0.</li>
</ul>

<p>You should experiment with these values and see how they change what you see in the scene.</p>

<div class="note">
<p><strong>Note</strong>: The distance values (e.g. for the camera z position) are unitless, and can be anything you deem suitable for your scene: milimeters, meters, feet, or miles. It's up to you.</p>
</div>

<h2 id="Rendering_the_scene">Rendering the scene</h2>

<p>Everything is ready, but we still can't see anything. Although we've set-up the renderer, we still need to render everything. Our <code>render()</code> function will do this job, with a little help from <code><a href="/en-US/docs/Web/API/window/requestAnimationFrame">requestAnimationFrame()</a></code>, which causes the scene to be re-rendered constantly on every frame:</p>

<pre class="brush: js">function render() {
	requestAnimationFrame(render);
	renderer.render(scene, camera);
}
render();
</pre>

<p>On every new frame the <code>render</code> function is invoked, and the <code>renderer</code> renders the <code>scene</code> and the <code>camera</code>. Right after the function declaration, we're invoking it for the first time to start the loop, after which it will be used indefinitely.</p>

<p>Again, add this new code below your previous additions. Try saving the file and opening it in your browser. You should now see a gray window. Congratulations!</p>

<h2 id="Geometry">Geometry</h2>

<p>Now our scene is properly rendering, we can start adding 3D shapes. To speed up development, Three.js provides a bunch of predefined primitives, which you can use to create shapes instantly in a single line of code. There's cubes, spheres, cylinders, and more complicated shapes available. Detail like drawing required vertices and faces, for a given shape, is handled by the Three framework, so we can focus on higher level coding. Let's start, by defining the geometry for a cube shape, adding the following just above the <code>render()</code> function:</p>

<pre class="brush: js">var boxGeometry = new THREE.BoxGeometry(10, 10, 10);
</pre>

<p>In this case, we define a simple cube that is 10 x 10 x 10 units. The geometry itself is not enough though, we also need a material that will be used for our shape.</p>

<h2 id="Material">Material</h2>

<p>A material is what covers an object, the colors, or textures on its surface. In our case, we will choose a simple blue color to paint our box. There are a number of predefined materials which can be used: Basic, Phong, Lambert. Let's play with the last two later, but for now, the Basic one should be enough:</p>

<pre class="brush: js">var basicMaterial = new THREE.MeshBasicMaterial({color: 0x0095DD});
</pre>

<p>Add this line below the previously added.</p>

<p>Our material is now ready, what next?</p>

<h2 id="Mesh">Mesh</h2>

<p>To apply the material to a geometry, a mesh is used. This takes on a shape, and adds the specified material to every face:</p>

<pre class="brush: js">var cube = new THREE.Mesh(boxGeometry, basicMaterial);
</pre>

<p>Again, add this line below the one you previously added.</p>

<h2 id="Adding_the_cube_to_the_scene">Adding the cube to the scene</h2>

<p>We've now created a cube, using the geometry and material defined earlier. The last thing to do is to place the cube to our scene. Add this line below the previous one:</p>

<pre class="brush: js">scene.add(cube);
</pre>

<p>If you save, and refresh your Web browser, our object will now look like a square, because it's facing the camera. The good thing about objects, is that we can move them on the scene, however we want. For example, rotating and scaling as we like. Let's apply a little rotation to the cube, so we can see more than one face.  Again, adding our code below the previous:</p>

<pre class="brush: js">cube.rotation.set(0.4, 0.2, 0);
</pre>

<p>Congratulations, you've created an object in a 3D environment! This might have proven easier than you first thought? Here's how it should look:</p>

<p><img alt="Blue cube on a gray background rendered with Three.js." src="https://mdn.mozillademos.org/files/11849/cube.png" style="display: block; height: 400px; margin: 0px auto; width: 600px;"></p>

<p>And here's the code we have created so far:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/bwup75fa/","","350")}}</p>

<p>You can also <a href="https://github.com/end3r/MDN-Games-3D/blob/gh-pages/Three.js/cube.html">check it out on GitHub</a>.</p>

<h2 id="More_shapes_and_materials">More shapes and materials</h2>

<p>Now we will add more shapes to the scene, and explore other shapes, materials, lighting, and more. Let's move the cube to the left, to make space for some friends. Adding the following line just below the previous one:</p>

<pre class="brush: js">cube.position.x = -25;
</pre>

<p>Now onto more shapes and materials. What might happen when you add a torus, wrapped in the Phong material? Try adding the following lines, just below the lines defining the cube.</p>

<pre class="brush: js">var torusGeometry = new THREE.TorusGeometry(7, 1, 6, 12);
var phongMaterial = new THREE.MeshPhongMaterial({color: 0xFF9500});
var torus = new THREE.Mesh(torusGeometry, phongMaterial);
scene.add(torus);
</pre>

<p>These lines will add a torus geometry; the <code>TorusGeometry()</code> method's parameters define, and the parameters are <code>radius</code>, <code>tube diameter</code>, <code>radial segment count</code>, and <code>tubular segment count</code>. The Phong material should look more glossy than the box's simple Basic material, though right now our torus will just look black.</p>

<p>We can choose more fun predefined shapes. Let's play some more. Add the following lines, below those defining the torus:</p>

<pre class="brush: js">var dodecahedronGeometry = new THREE.DodecahedronGeometry(7);
var lambertMaterial = new THREE.MeshLambertMaterial({color: 0xEAEFF2});
var dodecahedron = new THREE.Mesh(dodecahedronGeometry, lambertMaterial);
dodecahedron.position.x = 25;
scene.add(dodecahedron);
</pre>

<p>This time, we are creating a dodecahedron, a shape containing twelve flat faces. The parameter, <code>DodecahedronGeometry(),</code> defines the size of the object. We're using a Lambert material, similar to Phong, but should be less glossy. Again it's black, for now. We're moving the object to the right, so it's not in the same position as the box, or torus.</p>

<p>As mentioned above, the new objects currently just look black. To have both, the Phong and Lambert materials properly visible, we need to introduce a source of light.</p>

<h2 id="Lights">Lights</h2>

<p>There are various types of light sources available in Three.js. The most basic is <code>PointLight</code>, which works like a flashlight, shining a spotlight in a defined direction. Add the following lines, below your shape definitions:</p>

<pre class="brush: js">var light = new THREE.PointLight(0xFFFFFF);
light.position.set(-10, 15, 50);
scene.add(light);
</pre>

<p>We define a white point of light, set its position a little away from the center of the scene, so it can light up some parts of the shapes, finally adding it to the scene. Now everything works as it should, all three shapes are visible. You should check the documentation for other types of lights, like Ambient, Directional, Hemisphere, or Spot. Experiment placing them on our scene, to see how they affect it.</p>

<p><img alt="Shapes: blue cube, dark yellow torus and dark gray dodecahedron on a gray background rendered with Three.js." src="https://mdn.mozillademos.org/files/11851/shapes.png" style="height: 400px; width: 600px;"></p>

<p>This looks a little boring though. In a game, something is usually happening. We might see animations and such. So let's try breathing a little life into these shapes, by animating them!</p>

<h2 id="Animation">Animation</h2>

<p>We already used rotation, to adjust the position of the cube. We can also scale the shapes, or change their positions. To show animation, we need to make changes to these values inside the render loop, so they update on each frame.</p>

<h3 id="Rotation">Rotation</h3>

<p>Rotating is straighforward. You add a value to a given direction of rotation on each frame. Add this line of code, right after the <code>requestAnimationFrame()</code> invocation inside the <code>render</code> function:</p>

<pre class="brush: js">cube.rotation.y += 0.01;
</pre>

<p>This rotates the cube on every frame, by a tiny bit, so the animation looks smooth.</p>

<h3 id="Scaling">Scaling</h3>

<p>We can also scale an object. Applying a constant value, we would make it grow, or shrink just once. Let's make things more interesting. First, we implement a helper variable, called <code>t,</code> for counting elapsed time. Add it right before the <code>render()</code> function:</p>

<pre class="brush: js">var t = 0;
</pre>

<p>Now let's increase the value by a given constant value, on each frame of the animation. Add the following lines, just below the <code>requestAnimationFrame()</code> invocation:</p>

<pre class="brush: js">t += 0.01;
torus.scale.y = Math.abs(Math.sin(t));
</pre>

<p>We use <code>Math.sin</code>, ending up with quite an interesting result. This scales the torus, repeating the process, as <code>sin</code> is a periodic function. We're wrapping the scale value in <code>Math.abs</code>, to pass the absolute values, greater or equal to 0. As sin is between -1 and 1,  negative values might render out torus in unexpected way. In this case it looks black half the time.</p>

<p>Now, onto movement.</p>

<h3 id="Moving">Moving</h3>

<p>Aside from rotation, and scaling, we can additionally move objects around the scene. Add the following, again just below our <code>requestAnimationFrame()</code> invocation:</p>

<pre class="brush: js">dodecahedron.position.y = -7*Math.sin(t*2);
</pre>

<p>This will move the dodecahedron up and down, by applying the <code>sin()</code> value to the y axis on each frame, and a little adjustment to make it look cooler. Try changing these values, to see how it affects the animations.</p>

<h2 id="Conclusion">Conclusion</h2>

<p>Here's the final code:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/rybr720u/","","350")}}</p>

<p>You can also <a href="https://github.com/end3r/MDN-Games-3D/blob/gh-pages/Three.js/shapes.html">see it on GitHub</a> and <a href="https://github.com/end3r/MDN-Games-3D/">fork the repository</a>, if you want to play with it locally. Now you understand the basics of Three.js, you can jump back to the parent page, <a href="/en-US/docs/Games/Techniques/3D_on_the_web">3D on the Web</a>.</p>

<p>You could also try learning raw WebGL, to gain a better understanding of what's going on underneath. See our <a href="/en-US/docs/Web/API/WebGL_API">WebGL documentation</a>.</p>
